/* atosecs.c (function version)
	returns the number of seconds in a time string.
       here: time string = hh:mm:sec.s, mm:sec.s, or secs.s
*/
 
/* usage: unsigned long int atosecs(char *time_string)

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXFIELDS 3
#define BUFSIZE 20
#define TRUE 1
#define FALSE 0
#define FLDSEP ':' /* separator within time string */

unsigned long int secs( unsigned long times[], int nfields);

unsigned long atosecs(char *time_string)
{
	char secsbuf[BUFSIZE];
	unsigned long times[MAXFIELDS]; /* store (hh,mm,sec.s) */
	static char filler[BUFSIZE];
	char temp[BUFSIZE];
	int timeok = TRUE;        /* flag for invalid time string */
	int flds  = 0;
	int nxtchr;
        int count = 0;      /* counts position within a numerical field */
	int decptflg = FALSE; /* flag to find multiple decimal pts. */

	nxtchr = *time_string;
	while (nxtchr  != '\0')  /* main loop */
	{
                if (nxtchr == FLDSEP){   /* field complete */
			if (timeok){
				temp[count] = '\0';
				times[flds] = atol(temp);
				++flds;
				count = 0;
				strcpy(temp,filler); /* zero out temp */
				   }
			}
                else {      /* expecting  numerical input */
			if (!((nxtchr >='0'&&nxtchr <='9')||
				(nxtchr == '.' && decptflg == FALSE)))
				timeok = FALSE;
                        temp[count++] = nxtchr;
		     }  
		if (nxtchr == '.') decptflg = TRUE;
		nxtchr = *++time_string;
	}
	temp[count] = '\0';
	if (timeok) {
                        /* process the last one */
                times[flds++] = atol(temp);           /* compute decimal time */
                return secs(times,flds); 
		} 
        else return (unsigned long)0;
}
				
/* secs:  convert (hrs,mins,sec.s) to sec.s
    secs(unsigned long times[], int nfields) */

unsigned long int secs(unsigned long times[],int nfields)
{
	unsigned long s = 0;
	int count = 0;

                while (count  < nfields) 
                        s = 60*s + times[count++];
	return s;
}
